package uk.ac.bbsrc.babraham.ChipMonk.Dialogs;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Hashtable;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import uk.ac.bbsrc.babraham.ChipMonk.ChipMonkApplication;

public class DataZoomSelector extends JDialog implements ActionListener, ChangeListener{

	private ChipMonkApplication application;
	private int currentMaxZoom;
	private JSlider slider;
	
	public DataZoomSelector(ChipMonkApplication application) {
		super(application,"Set Data Zoom");
		this.application = application;
		currentMaxZoom = (int)application.chromosomeViewer().maxLogRatio();
		
		getContentPane().setLayout(new BorderLayout());
		
		Hashtable labels = new Hashtable();
		labels.put(new Integer(1),new JLabel("  2-fold"));
		labels.put(new Integer(2),new JLabel("  4-fold"));
		labels.put(new Integer(3),new JLabel("  8-fold"));
		labels.put(new Integer(4),new JLabel("  16-fold"));
		labels.put(new Integer(5),new JLabel("  32-fold"));
		labels.put(new Integer(6),new JLabel("  64-fold"));
		labels.put(new Integer(7),new JLabel("  128-fold"));
		labels.put(new Integer(8),new JLabel("  256-fold"));
		
		slider = new JSlider(1,8,(int)currentMaxZoom);
		slider.setOrientation(JSlider.VERTICAL);
		slider.addChangeListener(this);
		slider.setMajorTickSpacing(1);
		slider.setPaintTrack(true);
		slider.setPaintLabels(true);
		slider.setLabelTable(labels);
		getContentPane().add(slider,BorderLayout.CENTER);
		
		JButton closeButton = new JButton("Close");
		getRootPane().setDefaultButton(closeButton);
		closeButton.addActionListener(this);
		
		getContentPane().add(closeButton,BorderLayout.SOUTH);
		
		
		setSize(150,300);
		setLocationRelativeTo(application);
		setVisible(true);
		
	}

	public void actionPerformed(ActionEvent ae) {
		setVisible(false);
		dispose();
	}

	public void stateChanged(ChangeEvent ce) {
		currentMaxZoom = slider.getValue();
		application.chromosomeViewer().setMaxLogRatio(currentMaxZoom);
	}
}
